javax.vecmath

## Class Matrix3d

- java.lang.Object
- - javax.vecmath.Matrix3d

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public class Matrix3d
      extends java.lang.Object
      implements java.io.Serializable, java.lang.Cloneable

  A double precision floating point 3 by 3 matrix. Primarily to support 3D rotations.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `double` | `m00` The first matrix element in the first row.
    `double` | `m01` The second matrix element in the first row.
    `double` | `m02` The third matrix element in the first row.
    `double` | `m10` The first matrix element in the second row.
    `double` | `m11` The second matrix element in the second row.
    `double` | `m12` The third matrix element in the second row.
    `double` | `m20` The first matrix element in the third row.
    `double` | `m21` The second matrix element in the third row.
    `double` | `m22` The third matrix element in the third row.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Matrix3d()` Constructs and initializes a Matrix3d to all zeros.
    `Matrix3d(double[] v)` Constructs and initializes a Matrix3d from the specified nine- element array.
    `Matrix3d(double m00, double m01, double m02, double m10, double m11, double m12, double m20, double m21, double m22)` Constructs and initializes a Matrix3d from the specified nine values.
    `Matrix3d(Matrix3d m1)` Constructs a new matrix with the same values as the Matrix3d parameter.
    `Matrix3d(Matrix3f m1)` Constructs a new matrix with the same values as the Matrix3f parameter.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(double scalar)` Adds a scalar to each component of this matrix.
    `void` | `add(double scalar, Matrix3d m1)` Adds a scalar to each component of the matrix m1 and places the result into this.
    `void` | `add(Matrix3d m1)` Sets the value of this matrix to the sum of itself and matrix m1.
    `void` | `add(Matrix3d m1, Matrix3d m2)` Sets the value of this matrix to the matrix sum of matrices m1 and m2.
    `java.lang.Object` | `clone()` Creates a new object of the same class as this object.
    `double` | `determinant()` Computes the determinant of this matrix.
    `boolean` | `epsilonEquals(Matrix3d m1, double epsilon)` Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false.
    `boolean` | `equals(Matrix3d m1)` Returns true if all of the data members of Matrix3d m1 are equal to the corresponding data members in this Matrix3d.
    `boolean` | `equals(java.lang.Object t1)` Returns true if the Object t1 is of type Matrix3d and all of the data members of t1 are equal to the corresponding data members in this Matrix3d.
    `void` | `getColumn(int column, double[] v)` Copies the matrix values in the specified column into the array parameter.
    `void` | `getColumn(int column, Vector3d v)` Copies the matrix values in the specified column into the vector parameter.
    `double` | `getElement(int row, int column)` Retrieves the value at the specified row and column of the specified matrix.
    `double` | `getM00()` Get the first matrix element in the first row.
    `double` | `getM01()` Get the second matrix element in the first row.
    `double` | `getM02()` Get the third matrix element in the first row.
    `double` | `getM10()` Get first matrix element in the second row.
    `double` | `getM11()` Get second matrix element in the second row.
    `double` | `getM12()` Get the third matrix element in the second row.
    `double` | `getM20()` Get the first matrix element in the third row.
    `double` | `getM21()` Get the second matrix element in the third row.
    `double` | `getM22()` Get the third matrix element in the third row .
    `void` | `getRow(int row, double[] v)` Copies the matrix values in the specified row into the array parameter.
    `void` | `getRow(int row, Vector3d v)` Copies the matrix values in the specified row into the vector parameter.
    `double` | `getScale()` Performs an SVD normalization of this matrix to calculate and return the uniform scale factor.
    `int` | `hashCode()` Returns a hash code value based on the data values in this object.
    `void` | `invert()` Inverts this matrix in place.
    `void` | `invert(Matrix3d m1)` Sets the value of this matrix to the matrix inverse of the passed matrix m1.
    `void` | `mul(double scalar)` Multiplies each element of this matrix by a scalar.
    `void` | `mul(double scalar, Matrix3d m1)` Multiplies each element of matrix m1 by a scalar and places the result into this.
    `void` | `mul(Matrix3d m1)` Sets the value of this matrix to the result of multiplying itself with matrix m1.
    `void` | `mul(Matrix3d m1, Matrix3d m2)` Sets the value of this matrix to the result of multiplying the two argument matrices together.
    `void` | `mulNormalize(Matrix3d m1)` Multiplies this matrix by matrix m1, does an SVD normalization of the result, and places the result back into this matrix this = SVDnorm(this*m1).
    `void` | `mulNormalize(Matrix3d m1, Matrix3d m2)` Multiplies matrix m1 by matrix m2, does an SVD normalization of the result, and places the result into this matrix this = SVDnorm(m1*m2).
    `void` | `mulTransposeBoth(Matrix3d m1, Matrix3d m2)` Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.
    `void` | `mulTransposeLeft(Matrix3d m1, Matrix3d m2)` Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.
    `void` | `mulTransposeRight(Matrix3d m1, Matrix3d m2)` Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.
    `void` | `negate()` Negates the value of this matrix: this = -this.
    `void` | `negate(Matrix3d m1)` Sets the value of this matrix equal to the negation of of the Matrix3d parameter.
    `void` | `normalize()` Performs singular value decomposition normalization of this matrix.
    `void` | `normalize(Matrix3d m1)` Perform singular value decomposition normalization of matrix m1 and place the normalized values into this.
    `void` | `normalizeCP()` Perform cross product normalization of this matrix.
    `void` | `normalizeCP(Matrix3d m1)` Perform cross product normalization of matrix m1 and place the normalized values into this.
    `void` | `rotX(double angle)` Sets the value of this matrix to a counter clockwise rotation about the x axis.
    `void` | `rotY(double angle)` Sets the value of this matrix to a counter clockwise rotation about the y axis.
    `void` | `rotZ(double angle)` Sets the value of this matrix to a counter clockwise rotation about the z axis.
    `void` | `set(AxisAngle4d a1)` Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.
    `void` | `set(AxisAngle4f a1)` Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.
    `void` | `set(double scale)` Sets the value of this matrix to a scale matrix with the passed scale amount.
    `void` | `set(double[] m)` Sets the values in this Matrix3d equal to the row-major array parameter (ie, the first three elements of the array will be copied into the first row of this matrix, etc.).
    `void` | `set(Matrix3d m1)` Sets the value of this matrix to the value of the Matrix3d argument.
    `void` | `set(Matrix3f m1)` Sets the value of this matrix to the double value of the Matrix3f argument.
    `void` | `set(Quat4d q1)` Sets the value of this matrix to the matrix conversion of the double precision quaternion argument.
    `void` | `set(Quat4f q1)` Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.
    `void` | `setColumn(int column, double[] v)` Sets the specified column of this matrix3d to the three values provided.
    `void` | `setColumn(int column, double x, double y, double z)` Sets the specified column of this matrix3d to the three values provided.
    `void` | `setColumn(int column, Vector3d v)` Sets the specified column of this matrix3d to the vector provided.
    `void` | `setElement(int row, int column, double value)` Sets the specified element of this matrix3f to the value provided.
    `void` | `setIdentity()` Sets this Matrix3d to identity.
    `void` | `setM00(double m00)` Set the first matrix element in the first row.
    `void` | `setM01(double m01)` Set the second matrix element in the first row.
    `void` | `setM02(double m02)` Set the third matrix element in the first row.
    `void` | `setM10(double m10)` Set first matrix element in the second row.
    `void` | `setM11(double m11)` Set the second matrix element in the second row.
    `void` | `setM12(double m12)` Set the third matrix element in the second row.
    `void` | `setM20(double m20)` Set the first matrix element in the third row.
    `void` | `setM21(double m21)` Set the second matrix element in the third row.
    `void` | `setM22(double m22)` Set the third matrix element in the third row.
    `void` | `setRow(int row, double[] v)` Sets the specified row of this matrix3d to the three values provided.
    `void` | `setRow(int row, double x, double y, double z)` Sets the specified row of this matrix3d to the 4 values provided.
    `void` | `setRow(int row, Vector3d v)` Sets the specified row of this matrix3d to the Vector provided.
    `void` | `setScale(double scale)` Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) and multiplying by the new scale.
    `void` | `setZero()` Sets this matrix to all zeros.
    `void` | `sub(Matrix3d m1)` Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).
    `void` | `sub(Matrix3d m1, Matrix3d m2)` Sets the value of this matrix to the matrix difference of matrices m1 and m2.
    `java.lang.String` | `toString()` Returns a string that contains the values of this Matrix3d.
    `void` | `transform(Tuple3d t)` Multiply this matrix by the tuple t and place the result back into the tuple (t = this*t).
    `void` | `transform(Tuple3d t, Tuple3d result)` Multiply this matrix by the tuple t and and place the result into the tuple "result" (result = this*t).
    `void` | `transpose()` Sets the value of this matrix to its transpose.
    `void` | `transpose(Matrix3d m1)` Sets the value of this matrix to the transpose of the argument matrix.

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### m00

          public double m00

      The first matrix element in the first row.

    - #### m01

          public double m01

      The second matrix element in the first row.

    - #### m02

          public double m02

      The third matrix element in the first row.

    - #### m10

          public double m10

      The first matrix element in the second row.

    - #### m11

          public double m11

      The second matrix element in the second row.

    - #### m12

          public double m12

      The third matrix element in the second row.

    - #### m20

          public double m20

      The first matrix element in the third row.

    - #### m21

          public double m21

      The second matrix element in the third row.

    - #### m22

          public double m22

      The third matrix element in the third row.

  - ### Constructor Detail

    - #### Matrix3d

          public Matrix3d(double m00,
                  double m01,
                  double m02,
                  double m10,
                  double m11,
                  double m12,
                  double m20,
                  double m21,
                  double m22)

      Constructs and initializes a Matrix3d from the specified nine values.
      Parameters:
        `m00` - the [0][0] element
        `m01` - the [0][1] element
        `m02` - the [0][2] element
        `m10` - the [1][0] element
        `m11` - the [1][1] element
        `m12` - the [1][2] element
        `m20` - the [2][0] element
        `m21` - the [2][1] element
        `m22` - the [2][2] element

    - #### Matrix3d

          public Matrix3d(double[] v)

      Constructs and initializes a Matrix3d from the specified nine- element array.
      Parameters:
        `v` - the array of length 9 containing in order

    - #### Matrix3d

          public Matrix3d(Matrix3d m1)

      Constructs a new matrix with the same values as the Matrix3d parameter.
      Parameters:
        `m1` - the source matrix

    - #### Matrix3d

          public Matrix3d(Matrix3f m1)

      Constructs a new matrix with the same values as the Matrix3f parameter.
      Parameters:
        `m1` - the source matrix

    - #### Matrix3d

          public Matrix3d()

      Constructs and initializes a Matrix3d to all zeros.

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Returns a string that contains the values of this Matrix3d.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        the String representation

    - #### setIdentity

          public final void setIdentity()

      Sets this Matrix3d to identity.

    - #### setScale

          public final void setScale(double scale)

      Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) and multiplying by the new scale.
      Parameters:
        `scale` - the new scale amount

    - #### setElement

          public final void setElement(int row,
                        int column,
                        double value)

      Sets the specified element of this matrix3f to the value provided.
      Parameters:
        `row` - the row number to be modified (zero indexed)
        `column` - the column number to be modified (zero indexed)
        `value` - the new value

    - #### getElement

          public final double getElement(int row,
                          int column)

      Retrieves the value at the specified row and column of the specified matrix.
      Parameters:
        `row` - the row number to be retrieved (zero indexed)
        `column` - the column number to be retrieved (zero indexed)
      Returns:
        the value at the indexed element.

    - #### getRow

          public final void getRow(int row,
                    Vector3d v)

      Copies the matrix values in the specified row into the vector parameter.
      Parameters:
        `row` - the matrix row
        `v` - the vector into which the matrix row values will be copied

    - #### getRow

          public final void getRow(int row,
                    double[] v)

      Copies the matrix values in the specified row into the array parameter.
      Parameters:
        `row` - the matrix row
        `v` - the array into which the matrix row values will be copied

    - #### getColumn

          public final void getColumn(int column,
                       Vector3d v)

      Copies the matrix values in the specified column into the vector parameter.
      Parameters:
        `column` - the matrix column
        `v` - the vector into which the matrix row values will be copied

    - #### getColumn

          public final void getColumn(int column,
                       double[] v)

      Copies the matrix values in the specified column into the array parameter.
      Parameters:
        `column` - the matrix column
        `v` - the array into which the matrix row values will be copied

    - #### setRow

          public final void setRow(int row,
                    double x,
                    double y,
                    double z)

      Sets the specified row of this matrix3d to the 4 values provided.
      Parameters:
        `row` - the row number to be modified (zero indexed)
        `x` - the first column element
        `y` - the second column element
        `z` - the third column element

    - #### setRow

          public final void setRow(int row,
                    Vector3d v)

      Sets the specified row of this matrix3d to the Vector provided.
      Parameters:
        `row` - the row number to be modified (zero indexed)
        `v` - the replacement row

    - #### setRow

          public final void setRow(int row,
                    double[] v)

      Sets the specified row of this matrix3d to the three values provided.
      Parameters:
        `row` - the row number to be modified (zero indexed)
        `v` - the replacement row

    - #### setColumn

          public final void setColumn(int column,
                       double x,
                       double y,
                       double z)

      Sets the specified column of this matrix3d to the three values provided.
      Parameters:
        `column` - the column number to be modified (zero indexed)
        `x` - the first row element
        `y` - the second row element
        `z` - the third row element

    - #### setColumn

          public final void setColumn(int column,
                       Vector3d v)

      Sets the specified column of this matrix3d to the vector provided.
      Parameters:
        `column` - the column number to be modified (zero indexed)
        `v` - the replacement column

    - #### setColumn

          public final void setColumn(int column,
                       double[] v)

      Sets the specified column of this matrix3d to the three values provided.
      Parameters:
        `column` - the column number to be modified (zero indexed)
        `v` - the replacement column

    - #### getScale

          public final double getScale()

      Performs an SVD normalization of this matrix to calculate and return the uniform scale factor. If the matrix has non-uniform scale factors, the largest of the x, y, and z scale factors will be returned. This matrix is not modified.
      Returns:
        the scale factor of this matrix

    - #### add

          public final void add(double scalar)

      Adds a scalar to each component of this matrix.
      Parameters:
        `scalar` - the scalar adder

    - #### add

          public final void add(double scalar,
                 Matrix3d m1)

      Adds a scalar to each component of the matrix m1 and places the result into this. Matrix m1 is not modified.
      Parameters:
        `scalar` - the scalar adder
        `m1` - the original matrix values

    - #### add

          public final void add(Matrix3d m1,
                 Matrix3d m2)

      Sets the value of this matrix to the matrix sum of matrices m1 and m2.
      Parameters:
        `m1` - the first matrix
        `m2` - the second matrix

    - #### add

          public final void add(Matrix3d m1)

      Sets the value of this matrix to the sum of itself and matrix m1.
      Parameters:
        `m1` - the other matrix

    - #### sub

          public final void sub(Matrix3d m1,
                 Matrix3d m2)

      Sets the value of this matrix to the matrix difference of matrices m1 and m2.
      Parameters:
        `m1` - the first matrix
        `m2` - the second matrix

    - #### sub

          public final void sub(Matrix3d m1)

      Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).
      Parameters:
        `m1` - the other matrix

    - #### transpose

          public final void transpose()

      Sets the value of this matrix to its transpose.

    - #### transpose

          public final void transpose(Matrix3d m1)

      Sets the value of this matrix to the transpose of the argument matrix.
      Parameters:
        `m1` - the matrix to be transposed

    - #### set

          public final void set(Quat4d q1)

      Sets the value of this matrix to the matrix conversion of the double precision quaternion argument.
      Parameters:
        `q1` - the quaternion to be converted

    - #### set

          public final void set(AxisAngle4d a1)

      Sets the value of this matrix to the matrix conversion of the double precision axis and angle argument.
      Parameters:
        `a1` - the axis and angle to be converted

    - #### set

          public final void set(Quat4f q1)

      Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.
      Parameters:
        `q1` - the quaternion to be converted

    - #### set

          public final void set(AxisAngle4f a1)

      Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.
      Parameters:
        `a1` - the axis and angle to be converted

    - #### set

          public final void set(Matrix3f m1)

      Sets the value of this matrix to the double value of the Matrix3f argument.
      Parameters:
        `m1` - the matrix3d to be converted to double

    - #### set

          public final void set(Matrix3d m1)

      Sets the value of this matrix to the value of the Matrix3d argument.
      Parameters:
        `m1` - the source matrix3d

    - #### set

          public final void set(double[] m)

      Sets the values in this Matrix3d equal to the row-major array parameter (ie, the first three elements of the array will be copied into the first row of this matrix, etc.).
      Parameters:
        `m` - the double precision array of length 9

    - #### invert

          public final void invert(Matrix3d m1)

      Sets the value of this matrix to the matrix inverse of the passed matrix m1.
      Parameters:
        `m1` - the matrix to be inverted

    - #### invert

          public final void invert()

      Inverts this matrix in place.

    - #### determinant

          public final double determinant()

      Computes the determinant of this matrix.
      Returns:
        the determinant of the matrix

    - #### set

          public final void set(double scale)

      Sets the value of this matrix to a scale matrix with the passed scale amount.
      Parameters:
        `scale` - the scale factor for the matrix

    - #### rotX

          public final void rotX(double angle)

      Sets the value of this matrix to a counter clockwise rotation about the x axis.
      Parameters:
        `angle` - the angle to rotate about the X axis in radians

    - #### rotY

          public final void rotY(double angle)

      Sets the value of this matrix to a counter clockwise rotation about the y axis.
      Parameters:
        `angle` - the angle to rotate about the Y axis in radians

    - #### rotZ

          public final void rotZ(double angle)

      Sets the value of this matrix to a counter clockwise rotation about the z axis.
      Parameters:
        `angle` - the angle to rotate about the Z axis in radians

    - #### mul

          public final void mul(double scalar)

      Multiplies each element of this matrix by a scalar.
      Parameters:
        `scalar` - The scalar multiplier.

    - #### mul

          public final void mul(double scalar,
                 Matrix3d m1)

      Multiplies each element of matrix m1 by a scalar and places the result into this. Matrix m1 is not modified.
      Parameters:
        `scalar` - the scalar multiplier
        `m1` - the original matrix

    - #### mul

          public final void mul(Matrix3d m1)

      Sets the value of this matrix to the result of multiplying itself with matrix m1.
      Parameters:
        `m1` - the other matrix

    - #### mul

          public final void mul(Matrix3d m1,
                 Matrix3d m2)

      Sets the value of this matrix to the result of multiplying the two argument matrices together.
      Parameters:
        `m1` - the first matrix
        `m2` - the second matrix

    - #### mulNormalize

          public final void mulNormalize(Matrix3d m1)

      Multiplies this matrix by matrix m1, does an SVD normalization of the result, and places the result back into this matrix this = SVDnorm(this*m1).
      Parameters:
        `m1` - the matrix on the right hand side of the multiplication

    - #### mulNormalize

          public final void mulNormalize(Matrix3d m1,
                          Matrix3d m2)

      Multiplies matrix m1 by matrix m2, does an SVD normalization of the result, and places the result into this matrix this = SVDnorm(m1*m2).
      Parameters:
        `m1` - the matrix on the left hand side of the multiplication
        `m2` - the matrix on the right hand side of the multiplication

    - #### mulTransposeBoth

          public final void mulTransposeBoth(Matrix3d m1,
                              Matrix3d m2)

      Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.
      Parameters:
        `m1` - the matrix on the left hand side of the multiplication
        `m2` - the matrix on the right hand side of the multiplication

    - #### mulTransposeRight

          public final void mulTransposeRight(Matrix3d m1,
                               Matrix3d m2)

      Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.
      Parameters:
        `m1` - the matrix on the left hand side of the multiplication
        `m2` - the matrix on the right hand side of the multiplication

    - #### mulTransposeLeft

          public final void mulTransposeLeft(Matrix3d m1,
                              Matrix3d m2)

      Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.
      Parameters:
        `m1` - the matrix on the left hand side of the multiplication
        `m2` - the matrix on the right hand side of the multiplication

    - #### normalize

          public final void normalize()

      Performs singular value decomposition normalization of this matrix.

    - #### normalize

          public final void normalize(Matrix3d m1)

      Perform singular value decomposition normalization of matrix m1 and place the normalized values into this.
      Parameters:
        `m1` - Provides the matrix values to be normalized

    - #### normalizeCP

          public final void normalizeCP()

      Perform cross product normalization of this matrix.

    - #### normalizeCP

          public final void normalizeCP(Matrix3d m1)

      Perform cross product normalization of matrix m1 and place the normalized values into this.
      Parameters:
        `m1` - Provides the matrix values to be normalized

    - #### equals

          public boolean equals(Matrix3d m1)

      Returns true if all of the data members of Matrix3d m1 are equal to the corresponding data members in this Matrix3d.
      Parameters:
        `m1` - the matrix with which the comparison is made
      Returns:
        true or false

    - #### equals

          public boolean equals(java.lang.Object t1)

      Returns true if the Object t1 is of type Matrix3d and all of the data members of t1 are equal to the corresponding data members in this Matrix3d.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `t1` - the matrix with which the comparison is made
      Returns:
        true or false

    - #### epsilonEquals

          public boolean epsilonEquals(Matrix3d m1,
                              double epsilon)

      Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false. The L-infinite distance is equal to MAX[i=0,1,2 ; j=0,1,2 ; abs(this.m(i,j) - m1.m(i,j)]
      Parameters:
        `m1` - the matrix to be compared to this matrix
        `epsilon` - the threshold value

    - #### hashCode

          public int hashCode()

      Returns a hash code value based on the data values in this object. Two different Matrix3d objects with identical data values (i.e., Matrix3d.equals returns true) will return the same hash code value. Two objects with different data members may return the same hash value, although this is not likely.
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        the integer hash code value

    - #### setZero

          public final void setZero()

      Sets this matrix to all zeros.

    - #### negate

          public final void negate()

      Negates the value of this matrix: this = -this.

    - #### negate

          public final void negate(Matrix3d m1)

      Sets the value of this matrix equal to the negation of of the Matrix3d parameter.
      Parameters:
        `m1` - the source matrix

    - #### transform

          public final void transform(Tuple3d t)

      Multiply this matrix by the tuple t and place the result back into the tuple (t = this*t).
      Parameters:
        `t` - the tuple to be multiplied by this matrix and then replaced

    - #### transform

          public final void transform(Tuple3d t,
                       Tuple3d result)

      Multiply this matrix by the tuple t and and place the result into the tuple "result" (result = this*t).
      Parameters:
        `t` - the tuple to be multiplied by this matrix
        `result` - the tuple into which the product is placed

    - #### clone

          public java.lang.Object clone()

      Creates a new object of the same class as this object.
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        a clone of this instance.
      Throws:
        `java.lang.OutOfMemoryError` - if there is not enough memory.
      Since:
        vecmath 1.3
      See Also:
        `Cloneable`

    - #### getM00

          public final double getM00()

      Get the first matrix element in the first row.
      Returns:
        Returns the m00.
      Since:
        vecmath 1.5

    - #### setM00

          public final void setM00(double m00)

      Set the first matrix element in the first row.
      Parameters:
        `m00` - The m00 to set.
      Since:
        vecmath 1.5

    - #### getM01

          public final double getM01()

      Get the second matrix element in the first row.
      Returns:
        Returns the m01.
      Since:
        vecmath 1.5

    - #### setM01

          public final void setM01(double m01)

      Set the second matrix element in the first row.
      Parameters:
        `m01` - The m01 to set.
      Since:
        vecmath 1.5

    - #### getM02

          public final double getM02()

      Get the third matrix element in the first row.
      Returns:
        Returns the m02.
      Since:
        vecmath 1.5

    - #### setM02

          public final void setM02(double m02)

      Set the third matrix element in the first row.
      Parameters:
        `m02` - The m02 to set.
      Since:
        vecmath 1.5

    - #### getM10

          public final double getM10()

      Get first matrix element in the second row.
      Returns:
        Returns the m10.
      Since:
        vecmath 1.5

    - #### setM10

          public final void setM10(double m10)

      Set first matrix element in the second row.
      Parameters:
        `m10` - The m10 to set.
      Since:
        vecmath 1.5

    - #### getM11

          public final double getM11()

      Get second matrix element in the second row.
      Returns:
        Returns the m11.
      Since:
        vecmath 1.5

    - #### setM11

          public final void setM11(double m11)

      Set the second matrix element in the second row.
      Parameters:
        `m11` - The m11 to set.
      Since:
        vecmath 1.5

    - #### getM12

          public final double getM12()

      Get the third matrix element in the second row.
      Returns:
        Returns the m12.
      Since:
        vecmath 1.5

    - #### setM12

          public final void setM12(double m12)

      Set the third matrix element in the second row.
      Parameters:
        `m12` - The m12 to set.
      Since:
        vecmath 1.5

    - #### getM20

          public final double getM20()

      Get the first matrix element in the third row.
      Returns:
        Returns the m20.
      Since:
        vecmath 1.5

    - #### setM20

          public final void setM20(double m20)

      Set the first matrix element in the third row.
      Parameters:
        `m20` - The m20 to set.
      Since:
        vecmath 1.5

    - #### getM21

          public final double getM21()

      Get the second matrix element in the third row.
      Returns:
        Returns the m21.
      Since:
        vecmath 1.5

    - #### setM21

          public final void setM21(double m21)

      Set the second matrix element in the third row.
      Parameters:
        `m21` - The m21 to set.
      Since:
        vecmath 1.5

    - #### getM22

          public final double getM22()

      Get the third matrix element in the third row .
      Returns:
        Returns the m22.
      Since:
        vecmath 1.5

    - #### setM22

          public final void setM22(double m22)

      Set the third matrix element in the third row.
      Parameters:
        `m22` - The m22 to set.
      Since:
        vecmath 1.5

Copyright 1996-2008 Sun Microsystems, Inc. All Rights Reserved. Use is subject to license terms.